﻿using NSubstitute;
using NSubstitute.Exceptions;
using NUnit.Framework;

namespace BusinessAssembly.Tests
{
    [TestFixture]
    public class CalculatorTests
    {
        [Test]
        [ExpectedException(typeof(CallNotReceivedException))]
        public void WithInterface()
        {
            var calculator = Substitute.For<ICalculator>();

            calculator.Add(1, 2);
            calculator.Received().Add(2, 2);

        }
        [Test]
        [ExpectedException(typeof(CallNotReceivedException))]
        public void WithNonVirtual()
        {
            var calculator = Substitute.For<NonVirtualCalculator>();

            calculator.Add(1, 2);
            calculator.Received().Add(2, 2);

        }
        [Test]
        [ExpectedException(typeof(CallNotReceivedException))]
        public void WithVirtual()
        {
            var calculator = Substitute.For<VirtualCalculator>();

            calculator.Add(1, 2);
            calculator.Received().Add(2, 2);

        }
    }
}