﻿using System;
using Mono.Cecil;
using Mono.Cecil.Cil;

namespace NonVirtualNSubstitute
{
    internal class MethodProcesser
    {

        public MethodDefinition MethodDefinition { get; set; }

        public void Execute()
        {
            var instructions = MethodDefinition.Body.Instructions;
       
            for (var index = 0; index < instructions.Count; index++)
            {
                var instruction = instructions[index];
                var genericInstanceMethod = instruction.Operand as GenericInstanceMethod;
                //TODO: check the real method being called using cecil
                //TODO: check a list of methods
                if ((genericInstanceMethod == null) || (genericInstanceMethod.Name != "Received"))
                {
                    continue;
                }
                var forward3Index = index + 3;
                if (forward3Index < instructions.Count)
                {
                    var forward3Instruction = instructions[forward3Index];
                    if (forward3Instruction.OpCode == OpCodes.Callvirt)
                    {
                        var methodReference = (MethodReference) forward3Instruction.Operand;
                        var methodDefinition = methodReference.Resolve();
                        if (!methodDefinition.IsVirtual)
                        {
                            throw new Exception(string.Format("{0} Is not virtual", methodReference.FullName));
                        }
                    }
                }
            }
        }
    }
}