﻿using System.Reflection;
using Mono.Cecil;

namespace NonVirtualNSubstitute
{
    public static class NonVirtualHelper
    {
        public static void CheckForNonVirtual()
        {
            var unitTestAssembly = Assembly.GetCallingAssembly();
                var codeBase = unitTestAssembly.CodeBase;
                var fileName = codeBase.Substring(8, codeBase.Length - 8);
            var moduleDefinition = ModuleDefinition.ReadModule(fileName);
            foreach (var typeDefinition in moduleDefinition.Types)
            {
                ProcessType(typeDefinition);
            }
        }

        private static void ProcessType(TypeDefinition typeDefinition)
        {
            foreach (var methodDefinition in typeDefinition.Methods)
            {
                var methodProcesser = new MethodProcesser{MethodDefinition = methodDefinition};
               methodProcesser.Execute();
            }
        }

    }
}
